module Fakecrm
  def self.embedded!
    require 'fakecrm/configuration'

    port = 4000 + rand(10000)
    url  = "http://localhost:#{port}/crm"

    if defined?(Infopark::Crm)
      Infopark::Crm.configure do |configuration|
        configuration.url = url
        configuration.login = "root"
        configuration.api_key = "deadbeef"
      end
    end

    pid = fork do
      require 'fakecrm'
      Fakecrm::Configuration.port = port
      Fakecrm::Configuration.database = 'sqlite::memory:'
      Fakecrm::Configuration.silent = true
      self.run!
      exit!
    end
    sleep(1)
    at_exit do
      begin
        Process.kill("INT", pid)
        Process.wait(pid)
      rescue Errno::ESRCH, Errno::ECHILD
      end
    end

    return [port, pid]
  end
end
