# -*- encoding : utf-8 -*-
require 'fakecrm/resource/account'

module Fakecrm
  class Contact
    include DataMapper::Resource

    property :id,                 Serial
    property :first_name,         String, :length => 64
    property :last_name,          String, :required => true, :length => 64

    property :email,              String
    property :login,              String, :unique => true

    belongs_to :account,          :required => false
    property :country,            String
    property :extended_address,   String
    property :fax,                String, :length => 32
    property :gender,             Enum['M', 'F', 'N'], :required => true
    property :job_title,          String, :length => 100
    property :language,           String, :required => true
    property :locality,           String
    property :merged_into_id,     String
    property :mobile_phone,       String, :length => 32
    property :name_prefix,        String, :length => 64
    property :org_name_address,   String
    property :org_unit_address,   String
    property :phone,              String, :length => 32
    property :postalcode,         String
    property :region,             String
    property :street_address,     String
    property :want_email,         Boolean, :default => true
    property :want_geo_location,  Boolean
    property :want_phonecall,     Boolean, :default => true
    property :want_snailmail,     Boolean, :default => true

    property :role_names,         CommaSeparatedList, :default => ''

    property :created_at,         DateTime
    property :changed_at,         DateTime # FIXME: doesn't work automatically
    property :updated_at,         DateTime
    property :deleted_at,         ParanoidDateTime

    property :updated_by,         String, :default => 'root'

    before :save do
      self.country = self.country.upcase unless self.country.nil?
    end
  end
end

