# -*- encoding : utf-8 -*-

require 'fakecrm/tolerant_mass_assignment'
module Fakecrm
  class EventContact
    include DataMapper::Resource
    include Fakecrm::TolerantMassAssignment

    property :id,                 Serial
    property :state,              Enum['unregistered', 'registered', 'attended', 'refused', 'noshow'], :required => true

    property :created_at,         DateTime
    property :changed_at,         DateTime
    property :updated_at,         DateTime
    property :deleted_at,         ParanoidDateTime

    property :updated_by,         String, :default => 'root'

    belongs_to :event, :required => true
    belongs_to :contact, :required => true
  end
end

