# -*- encoding : utf-8 -*-
require 'fakecrm/resource/custom_type'

module Fakecrm
  module Kinds
    def one_of_a_kind?
      true
    end
    def self.included(base)
      base.class_eval do
        property :kind,                   ::DataMapper::Property::String, :required => true

        validates_with_method :kind, :method => :check_kind

        def check_kind
          if CustomType.first(:name => self.kind, :kind => self.class.name.split('::').last)
            return true
          else
            return [false, "Custom type #{self.kind} not found"]
          end
        end
      end
    end
  end
end

