# -*- encoding : utf-8 -*-
require 'fakecrm/resource/account'
require 'fakecrm/resource/activity'
require 'fakecrm/resource/contact'
require 'fakecrm/resource/event'
require 'fakecrm/resource/event_contact'

require 'fakecrm/resource/extensions/type_extension'

require 'dm-types'

module Fakecrm
  class TypeExtender
    def initialize(custom_type)
      self.custom_type = custom_type
    end

    def extend!
      custom_attributes = self.custom_type.custom_attributes
      case self.custom_type.id
      when 'contact'
        TypeExtension.new(Contact).replace!(custom_attributes)
      when 'account'
        TypeExtension.new(Account).replace!(custom_attributes)
      else
        case self.custom_type.kind
        when 'Event'
          TypeExtension.new(Event).add!(custom_attributes)
        when 'Activity'
          TypeExtension.new(Activity).add!(custom_attributes)
        when 'EventContact'
          TypeExtension.new(EventContact).add!(custom_attributes)
        else
          true
        end
      end
    end

    attr_accessor :custom_type
  end
end

