# -*- encoding : utf-8 -*-
module Fakecrm
  class Template
    include DataMapper::Resource

    property :id,                 Serial
    property :body,               Json, :default => {}

    def templates
      system_default.merge(body)
    end

    private

    def system_default
      {
        "notification_email_to"=>"",
        "notification_email_from"=>"",
        "notification_email_reply_to"=>"",
        "notification_email_bcc"=>"",
        "notification_email_subject"=>"",
        "notification_email_body"=>"",
        "digest_email_from"=>"",
        "digest_email_reply_to"=>"",
        "digest_email_bcc"=>"",
        "digest_email_subject"=>"",
        "digest_email_body"=>"",
        "password_request_email_from"=>"",
        "password_request_email_reply_to"=>"",
        "password_request_email_bcc"=>"",
        "password_request_email_subject"=>"New Password Requested",
        "password_request_email_body"=>
        "To reset your password click the URL below:\r\n\r\n    {{password_request_url}}\r\n\r\nIf you did not request your password to be reset please ignore this email and your password will stay as it is.",
          "contact_salutation"=>
        "{% assign anr = '' %} \r\n{% if contact.name_prefix contains 'Dr.' %} \r\n{% assign anr = 'Dr. ' %} \r\n{% endif %} \r\n{% if contact.name_prefix contains 'Prof.' %} \r\n{% assign anr = 'Prof. ' %} \r\n{% endif %} \r\n\r\n{% case contact.gender %} \r\n{% when \"M\" %} \r\nSehr geehrter Herr {{anr}}{{contact.last_name}}, \r\n{% when \"F\" %} \r\nSehr geehrte Frau {{anr}}{{contact.last_name}}, \r\n{% else %} \r\nSehr geehrte Damen und Herren, \r\n{% endcase %}"
      }
    end

  end
end

