# -*- encoding : utf-8 -*-
module Fakecrm
  module Activities

    def self.included(base)
      base.class_eval do

        get '/crm/api/activities.?:format?' do
          fetch_many(Activity)
        end

        get '/crm/api/activities/search.?:format?' do |format|
          search(Activity, [:account_id, :contact_id, :kind, :state], [:title], params[:sort_by], params[:sort_order])
        end

        get '/crm/api/activities/:id.?:format?' do |id, format|
          fetch_one(Activity, id.to_i)
        end

        put '/crm/api/activities/:id.?:format?' do |id, format|
          update_one(Activity, id.to_i, Activity.transform_comment_params(params["activity"]))
        end

        post '/crm/api/activities.?:format?' do
          create_one(Activity, Activity.transform_comment_params(params["activity"]))
        end

        delete '/crm/api/activities/:id.?:format?' do |id, format|
          destroy_one(Activity, id.to_i)
        end

      end
    end

  end

end


