# -*- encoding : utf-8 -*-
module Fakecrm
  module EventContacts

    def self.included(base)
      base.class_eval do

        get '/crm/api/event_contacts.?:format?' do
          fetch_many(EventContact)
        end

        get '/crm/api/event_contacts/search.?:format?' do
          search(EventContact, [:event_id, :contact_id, :state], [],
                 params.fetch("sort_by", :updated_at).to_sym,
                 params.fetch("sort_order", 'asc').to_s)
        end

        get '/crm/api/event_contacts/:id.?:format?' do |id, _|
          fetch_one(EventContact, id.to_i)
        end

        post '/crm/api/event_contacts.?:format?' do
          create_one(EventContact, params["event_contact"])
        end

        put '/crm/api/event_contacts/:id.?:format?' do |id, _|
          update_one(EventContact, id.to_i, params["event_contact"])
        end

        delete '/crm/api/event_contacts/:id.?:format?' do |id|
          destroy_one(EventContact, id.to_i)
        end

      end
    end
  end
end

