# -*- encoding : utf-8 -*-
module Fakecrm
  module Events

    def event_params
      event = params["event"].dup
      event.delete("name")
      event
    end

    def self.included(base)
      base.class_eval do

        get '/crm/api/events.?:format?' do
          fetch_many(Event)
        end

        get '/crm/api/events/search.?:format?' do
          search(Event, [:event_set, :kind], [:title],
                 params.fetch("sort_by", :updated_at).to_sym,
                 params.fetch("sort_order", 'asc').to_s)
        end

        get '/crm/api/events/:id.?:format?' do |id, _|
          fetch_one(Event, id.to_i)
        end

        post '/crm/api/events.?:format?' do
          create_one(Event, event_params)
        end

        put '/crm/api/events/:id.?:format?' do |id, _|
          update_one(Event, id.to_i, event_params)
        end

        delete '/crm/api/events/:id.?:format?' do |id|
          destroy_one(Event, id.to_i)
        end

      end
    end

  end

end


