# -*- encoding : utf-8 -*-
module Fakecrm
  module Roles

    def role_params
      allowed_keys = Role.properties.map(&:name)
      allowed = {}
      params.fetch("role", {}).each do |key, value|
        allowed[key] = value if allowed_keys.include?(key.to_sym)
      end
      allowed
    end

    def self.included(base)
      base.class_eval do

        get '/crm/api/roles.?:format?' do |format|
          fetch_many(Role)
        end

        get '/crm/api/roles/:id.?:format?' do |id, format|
          fetch_one(Role, id)
        end

        put '/crm/api/roles/:id.?:format?' do |id, format|
          update_one(Role, id, role_params)
        end

        post '/crm/api/roles.?:format?' do |format|
          create_one(Role, role_params)
        end

        delete '/crm/api/roles/:id.?:format?' do |id, format|
          destroy_one(Role, id)
        end

      end
    end

  end

end


